<?php

  // --------------------------------------------------------------------------------------

  $on_host = strtoupper( substr( PHP_OS, 0, 3)) === 'WIN' ? false : true;
  $prefix  = '';
  $caller  = 'motd_playlist';

  if( $on_host)
  {
    $prefix = '../../playlist_stuff/';
  }


  if( ! defined( 'IN_PLAYLIST'))
  {
    define( 'IN_PLAYLIST', 1);
  }
  require_once( $prefix . 'playlist_settings.php');
  require_once( $prefix . 'playlist_tools.php'   );

  $bh_debug = true;            // Allow for debug info to clutter up the page

  // include( "assert_stream_op.php");


  bh_set_uncached();           // This file works on live data, so it should not be cached

  // --------------------------------------------------------------------------------------

  // --------------------------------------------------------------------------------------
  //
  // Activity options

  $bh_motd_auto_active    = true;   // Set to false to disable auto motd from schedule.


  // --------------------------------------------------------------------------------------
  //
  // Visibility time slot for auto MOTD items

  $bh_pre_show_time  = 24 * $bh_secondsInHour;      // Seconds before show time that show
                                                    // will show up in auto MOTD.
  $bh_post_show_time =  5 * $bh_secondsInMinute;    // Seconds after show item will still
                                                    // be visible in auto MOTD.


  // --------------------------------------------------------------------------------------
  //
  // Cache validity time, make a new one if its older than this
  // Set to one minute to keep some responsiveness on changes

  $bh_cache_time    =  1 * $bh_secondsInMinute;   // Cache timeout time in seconds.


  // --------------------------------------------------------------------------------------
  //
  // Debug options

  $bh_debug             = false;  // Run in debug mode, outputs stuff not usually shown.
                                  // normally : false
  $bh_use_time_debug    = false;  // Set to true to enable the time issue debugger, only
                                  // effective if $bh_debug is  on.
                                  // normally : false
  $bh_cache_debug       = false;  // Set to true to see what caching actions are being
                                  // performed.
                                  // normally : false
  $bh_use_cache_file    = false;   // Set to false to disable reading from cache (handy for
                                  // debugging at times).
                                  // normally : true
  $bh_write_cache_file  = true;   // Set to false to disable writing to cache (handy for
                                  // debugging at times).
                                  // normally : true


  // --------------------------------------------------------------------------------------
  //
  // Content generators

  function bh_motd_prefix()
  {
    $result = ""
      . "<!-- make_motd.php -->\r"
      . "<script type = \"text/javascript\">\r"
      . "  function gmt2local( year, month, day, hour, minute)\r"
      . "  {\r"
      . "    d    = new Date( Date.UTC( year, month - 1, day, hour, minute));\r"
      . "    hour = d.getHours();\r"
      . "    tag  = \" AM\";\r"
      . "    mt   = \"\" + (( hour < 10) ?  \"0\" : \"\") + hour;\r"
      . "    if( hour > 11)\r"
      . "    {\r"
      . "      tag   = \" PM\";\r"
      . "    }\r"
      . "    if( hour > 12)\r"
      . "    {\r"
      . "      hour -= 12;\r"
      . "    }\r"
      . "    if( hour == 0)\r"
      . "    {\r"
      . "      hour = 12;\r"
      . "    }\r"
      . "\r"
      . "    minute  = d.getMinutes();\r"
      . "    result  = \"\" + hour;\r"
      . "    mt     += (( minute < 10) ? \":0\" : \":\") + minute;\r"
      . "    result += (( minute < 10) ? \":0\" : \":\") + minute;\r"
      . "    result += tag + \" [ \" + mt +\" ]\";\r"
      . "    document.write( result);\r"
      . "    return result;\r"
      . "  }\r"
      . "\r"
      . "  function show_chat()\r"
      . "  {\r"
      . "    window.open( 'http://electro-music.com/forum/chat.php', '_phpbbpjircpop', 'WIDTH=700, HEIGHT=508, resizable=yes, scrollbars=no');\r"
      . "    return false;\r"
      . "  }\r"
      . "</script>\r"
      . "\r"
      . "<style type = \"text/css\">\r"
      . "  .prim\r"
      . "  {\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 15pt;\r"
      . "  }\r"
      . "  .subprim\r"
      . "  {\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 13pt;\r"
      . "    text-align       : right;\r"
      . "  }\r"
      . "  .sec\r"
      . "  {\r"
      . "    background-color : #efefef;\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 9pt;\r"
      . "    padding-left     : 8px;\r"
      . "    padding-right    : 8px;\r"
      . "  }\r"
      . "  .sright\r"
      . "  {\r"
      . "    background-color : #efefef;\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 9pt;\r"
      . "    padding-left     : 8px;\r"
      . "    padding-right    : 8px;\r"
      . "    text-align       : right;\r"
      . "  }\r"
      . "  .scenter\r"
      . "  {\r"
      . "    background-color : #efefef;\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 9pt;\r"
      . "    padding-left     : 8px;\r"
      . "    padding-right    : 8px;\r"
      . "    text-align       : center;\r"
      . "  }\r"
      . "  .live\r"
      . "  {\r"
      . "    background-color : #255293;\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 9pt;\r"
      . "    font-weight      : bold;\r"
      . "    color            : white;\r"
      . "    padding-left     : 8px;\r"
      . "    padding-right    : 8px;\r"
      . "  }\r"
      . "  td.hsec\r"
      . "  {\r"
      . "    background-color : #D1D7DC;\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 9pt;\r"
      . "    padding-left     : 8px;\r"
      . "    padding-right    : 8px;\r"
      . "  }\r"
      . "  td.hsright\r"
      . "  {\r"
      . "    background-color : #D1D7DC;\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 9pt;\r"
      . "    padding-left     : 8px;\r"
      . "    padding-right    : 8px;\r"
      . "    text-align       : right;\r"
      . "  }\r"
      . "  td.hscenter\r"
      . "  {\r"
      . "    background-color : #D1D7DC;\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 9pt;\r"
      . "    padding-left     : 8px;\r"
      . "    padding-right    : 8px;\r"
      . "    text-align       : center;\r"
      . "  }\r"
      . "  a.live\r"
      . "  {\r"
      . "    color            : white;\r"
      . "    text-decoration  : none;\r"
      . "  }\r"
      . "  a.live:link\r"
      . "  {\r"
      . "    color            : white;\r"
      . "  }\r"
      . "  a.live:active\r"
      . "  {\r"
      . "    color            : white;\r"
      . "  }\r"
      . "  a.live:visited\r"
      . "  {\r"
      . "    color            : white;\r"
      . "  }\r"
      . "  a.live:hover\r"
      . "  {\r"
      . "    color            : #febcbc;\r"
      . "    text-decoration  : underline;\r"
      . "  }\r"
      . "  .tert\r"
      . "  {\r"
      . "    font-family      : Verdana, arial, helvetica, sans-serif;\r"
      . "    font-size        : 9pt;\r"
      . "  }\r"
      . "</style>\r"
      . "<table align = \"center\" width = \"100%\">\r"
      . "  <tbody>\r"
      . "    <tr>\r"
      . "      <td>\r"
      . "        <table align = \"center\">\r"
      . "          <tbody>\r"
      . "            <tr>\r"
      . "              <td align = \"center\">\r"
      . "                <span class = \"prim\">\r"
      . "                  Currently on the playlist at\r"
      . "                  <a href = \"http://radio.electro-music.com\" target = \"_blank\">radio.electro-music.com</a>\r"
      . "                </span>\r"
      . "                <br><br>\r"
      . "                <table>\r"
      . "                  <tr>\r"
      . "                    <td class = \"hscenter\">&nbsp;</td>\r"
      . "                    <td class = \"hsec\">author</td>\r"
      . "                    <td class = \"hsec\">list</td>\r"
      . "                    <td class = \"hsright\">at your time</td>\r"
      . "                  </tr>\r";

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_motd_row( $live, $year, $month, $day, $hour, $minute, $author, $list, $port)
  {
    $live_elt  = $live ? "live" : "sec";
    $live_lnk  = $live ? "<a href=\"http://electro-music.com/radio/listen_$port.m3u\" target=\"_blank\" class=\"live\">&lt;on&nbsp;air&gt;</a>" : "&nbsp;";
    $author    = htmlentities( $author, ENT_COMPAT, 'UTF-8');
    $list      = htmlentities( $list  , ENT_COMPAT, 'UTF-8');

    $result = ""
      . "                  <tr>\r"
      . "                    <td class = \"$live_elt\">$live_lnk</td>\r"
      . "                    <td class = \"sec\">$author</td>\r"
      . "                    <td class = \"sec\">$list</td>\r"
      . "                    <td class = \"sright\"><script type = text/javascript> gmt2local( $year, $month, $day, $hour, $minute); </script></td>\r"
      . "                  </tr>\r";

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_empty_motd_row()
  {
    $result = ""
      . "                  <tr>\r"
      . "                    <td class = \"hsec\" height=\"3\"></td>\r"
      . "                    <td class = \"hsec\" height=\"3\"></td>\r"
      . "                    <td class = \"hsec\" height=\"3\"></td>\r"
      . "                    <td class = \"hsec\" height=\"3\"></td>\r"
      . "                  </tr>\r";

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_motd_postfix()
  {
    $result = ""
      . "                </table>\r"
      . "                <span class = \"tert\">\r"
      . "                  Please visit the\r"
      . "                  <a\r"
      . "                    href    = \"http://www.electro-music.com/forum/chat.php\"\r"
      . "                    target  = \"_blank\"\r"
      . "                    onclick = \"return show_chat();\"\r"
      . "                  >chat</a>\r"
      . "                </span>\r"
      . "              </td>\r"
      . "            </tr>\r"
      . "          </tbody>\r"
      . "        </table>\r"
      . "      </td>\r"
      . "    </tr>\r"
      . "  </tbody>\r"
      . "</table>\r"
      . "<!-- end make_motd.php -->\r";

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function makeMotd()
  {
    global $bh_secondsInMinute;
    global $bh_motd_auto_active;
    global $bh_pre_show_time;
    global $bh_post_show_time;
    global $bh_cache_time;
    global $bh_test_port;
    global $bh_main_port;
    global $bh_motd_cache_fn;
    global $bh_schedule_file;
    global $bh_debug;
    global $bh_use_time_debug;
    global $bh_cache_debug;
    global $bh_use_cache_file;
    global $bh_write_cache_file;

    $now        = time();                   // Current time in UTC as unix time.
    $result     = '';                       // assume we generate nothing
    $used_cache = false;                    // and that we have no (valid) cache

    if(
      $bh_use_cache_file &&                 // Do we want to use the cache file?
      file_exists( $bh_motd_cache_fn)       // Does a cache file exist?
    )
    {
      // Try to use the cache file

      if( $bh_cache_debug)
      {
        print( "motd is on, we want to use a cache file and cache file exists<br>\r\n");
      }

      // Check if cache is not too old to use, and if it's readable

      $bh_file_time  = filemtime( $bh_motd_cache_fn);
      $bh_clock_time = time();
      $bh_time_out   = $bh_file_time + $bh_cache_time;

      if( $bh_cache_debug)
      {
        $pretty_file_time  = bh_format_utc( $bh_file_time);
        $pretty_clock_time = bh_format_utc( $bh_clock_time);
        $pretty_time_out   = bh_format_utc( $bh_time_out);

        print( "file time is $pretty_file_time,<br>clock time is $pretty_clock_time,<br>timeout time is $pretty_time_out<br>\r\n");
      }

      if( $bh_clock_time < $bh_time_out)
      {
        if( $bh_cache_debug)
        {
          print( "cache is recent, try to use it<br>\r\n");
        }

        $result = bh_locked_get_contents( $bh_motd_cache_fn);

        if( $result === false)
        {
          if( $bh_cache_debug)
          {
            print( "cache read failed, do not use it<br>\r\n");
          }

          $result = '';
        }
        else
        {
          if( $bh_cache_debug)
          {
            print( "cache read ok, use it<br>\r\n");
          }

          $used_cache = true;
        }
      }
      else
      {
        if( $bh_cache_debug)
        {
          print( "cache is old, not reading it<br>\r\n");
        }
      }
    }

    // --------------------------------------------------------------------------------------
    //
    // Check if cache was used, if not generate new contents

    if( ! $used_cache || ! $bh_use_cache_file)
    {

      // ------------------------------------------------------------------------------------
      //
      // ==== 2011-02-13 : add auto MOTD from playlist schedule ====

      if( $bh_motd_auto_active)
      {
        // ----------------------------------------------------------------------------------
        //
        // Read stored motd data into $sched array for possible inclusion into MOTD
        //
        // Stored data is a CSV file with the following data :
        //
        //   id, visible, live, day, date, time, author, list

        $bh_text  = '';
        $bh_sched = bh_load_schedule( $bh_schedule_file);

        // **1 : a sort step should has been inserted before the presentation step.

        if( $bh_use_time_debug)
        {
          print( "time debugging is on<br>\r\n");
        }

        $bh_sorter = array();            // To collect items for a later sort

        $index = 0;
        foreach( $bh_sched as $d)
        {
          if( $index > 1)               // Skip the default list and the filler
          {

            // Collect items that are visible, active, and within a reasonable time frame,
            // also determine if it's live according to the schedule.

            $bh_visible       = $d[ 'visible'   ];
            $bh_auto_motd     = $d[ 'playable'  ];
            $bh_week_day      = $d[ 'day'       ];
            $bh_schedule_type = $d[ 'type'      ];
            $bh_anchor        = $d[ 'anchor'    ];
            $bh_start_time    = $d[ 'start'     ];
            $bh_duration      = $d[ 'duration'  ] * $bh_secondsInMinute; // make duration to be seconds
            $bh_author        = $d[ 'author'    ];
            $bh_list          = $d[ 'file'      ];
            $bh_auto_reset    = $d[ 'auto_reset'];
            $bh_day_mask      = $d[ 'day_mask'  ];

            if( $bh_use_time_debug)
            {
              print( "----- ----- ----- ----- -----<br>\r\n");
              print( "playlist ($bh_author, $bh_list): ($bh_week_day), ($bh_schedule_type), ($bh_anchor), ($bh_start_time), ($bh_duration)<br>\r\n");
            }

            // See if visible and active

            if
            (
              ( $bh_visible   === "on") &&        // Item visible at all?
              ( $bh_auto_motd === "on")           // Item enabled for auto-motd?
            )
            {
              // See if within reasonable time frame

              $bh_show_start  = bh_makeStartTime( $bh_list, $now, $bh_week_day, $bh_day_mask, $bh_schedule_type, $bh_anchor, $bh_start_time, $bh_duration + $bh_post_show_time);
              $bh_frame_start = $bh_show_start - $bh_pre_show_time;
              $bh_show_end    = $bh_show_start + $bh_duration;
              $bh_frame_end   = $bh_show_start + $bh_duration + $bh_post_show_time;

              bh_debug_time( $bh_frame_start, 'visibility frame start');
              bh_debug_time( $bh_show_start , 'show start'            );
              bh_debug_time( $bh_show_end   , 'show end'              );
              bh_debug_time( $bh_frame_end  , 'visibility frame end'  );

              if(( $now >= $bh_frame_start) && ( $now <= $bh_frame_end))
              {
                bh_debug_time( $bh_show_start, 'point 60 - in visible time frame');

                $bh_is_live = ( $now >= $bh_show_start) && ( $now <= $bh_show_end);
                $bh_info    = getdate( $bh_show_start);

                $bh_sorter[] = array(
                  "start_time"  => $bh_show_start,
                  "is_live"     => $bh_is_live,
                  "year"        => $bh_info[ "year"   ],
                  "month"       => $bh_info[ "mon"    ],
                  "mday"        => $bh_info[ "mday"   ],
                  "hours"       => $bh_info[ "hours"  ],
                  "minutes"     => $bh_info[ "minutes"],
                  "author"      => $bh_author,
                  "list"        => $bh_list
                );
              }
              else
              {
                bh_debug_time( $bh_show_start, 'point 60 : not in visible time frame');
              }
            }
          }
          $index++;
        }

        // Sort $sorter on first column (start_time)
        // Don't use anonymous function here our PHP Version is 5.1.6 ( < 5.3.0 ).

        function bh_cmp( $a, $b)
        {
          return (int) $a[ "start_time"] - (int) $b[ "start_time"];
        }

        usort( $bh_sorter, "bh_cmp");

        // Then use the items for $result

        if(( count( $bh_sorter) > 0) && ($result !== ""))
        {
          $result.= bh_empty_motd_row();
        }

        foreach( $bh_sorter as $d)
        {
          $result .=
            bh_motd_row(
              $d[ "is_live"  ],
              $d[ "year"     ],
              $d[ "month"    ],
              $d[ "mday"     ],
              $d[ "hours"    ],
              $d[ "minutes"  ],
              $d[ "author"   ],
              $d[ "list"     ],
              $bh_test_port
            );
        }
      }
      // ==== End auto MOTD ====


      // ------------------------------------------------------------------------------------
      //
      // ==== some fixups and cache handling ====

      if( $result !== '')
      {
        $result = bh_motd_prefix() . $result . bh_motd_postfix();
      }
      else
      {
        if( $bh_debug)
        {
          print( '$result has no contents');
        }
      }

      // ------------------------------------------------------------------------------------
      //
      // Cache the results, if needed

      if( $bh_write_cache_file) // do we want to write the cache?
      {
        if( $bh_cache_debug)
        {
          print( 'writing cache file');
        }
        file_put_contents( $bh_motd_cache_fn, $result, LOCK_EX);
      }
      else
      {
      if( $bh_cache_debug)
      {
        print( 'cache writing is off, not writing cache');
      }
      }
    }

    // Either cached or new contents here, some debug stuff (if turned on)

    if( $bh_debug)
    {
      print( $result);
    }


    if( $result === "")
    {
      $result = "\r\n<!-- no radio info found -->\r\n";
    }

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  if(
    $bh_motd_auto_active              // Auto MOTD
  )
  {
    $radio = makeMotd();
  }
  else
  {
    $radio = '\r\n<!-- all motd stuff was turned off in make_motd.php -->\r\n';
  }

  print( $radio);

  // $bh_run_time = microtime( true) - $bh_run_time;
  // print( "run time : $bh_run_time<br>\r\n");

?>
