<?php

  // todo :
  //
  //   2012-07-31 : option to end scheduled playlist and not repeat. [If it is shorter than the scheduled time].
  //
  //   2012-07-31 : option to fade out scheduled playlist at it's scheduled time and not to run over. [thus
  //                wiping out anything that follows directly in the schedule.]
  //
  //   2012-08-05 : Les wants playlists to fuck.
  //
  // done :
  //
  //   2012-07-20 : Just one problem left ... when a regular item becomes live soon and we picked items
  //                from the default list the scheduled item will start late .. or not at all. This is not
  //                easy to fix within this program ...
  //
  //                hmm .. returning random tracks now here and there to fill gaps and such ... not really
  //                a great idea maybe as the tracks will change on each call ... it'll do for now.
  //
  //   2012-07-31 : Added clear option for playlist pointers.
  //
  //   2012-08-04 : Made daily playlists work.
  //
  //   2012-08-05 : fixed playlist cache tools on server so that it has info on the station calls too.
  //
  //   2012-08-05 : phobos__the_minikp_sessions__03_kaoss_feedback_drone_excerpt_may_06_2011_293 wont go into
  //                the cache ??? - playlist_sort.php (the playlist sorter / organizer) had a field limit
  //                of 120 characters on the track name - set that to 512 to fix it; the cache was okay.
  //
  //   2012-08-06 : made support for auto song pointer reset when a schedule item gets scheduled
  //


  // //////////////////////////////////////////////////////////////////////////
  //
  // definitions

  $on_host = strtoupper( substr( PHP_OS, 0, 3)) === 'WIN' ? false : true;
  if( ! defined( 'IN_PLAYLIST'))
  {
    define( 'IN_PLAYLIST', 1);
  }
  require_once( 'playlist_settings.php');           // Global settings for finding stuff
  require_once( 'playlist_tools.php'   );           // Supporting code

  // For production code all debugging needs to be off, for debugging specify it on the command line

  $bh_debug          = bh_read_get_param( 'debug'        , 1, false); // Overall debugging
  $bh_use_time_debug = bh_read_get_param( 'time_debug'   , 1, false); // Schedule timing debugging
  $bh_cache_debug    = bh_read_get_param( 'cache_debug'  , 1, false); // Caching actions debugging
  $bh_pointer_debug  = bh_read_get_param( 'pointer_debug', 1, false); // playlist pointer debugging


  // --------------------------------------------------------------------------------------
  //
  // Visibility window

  $bh_pre_file_time  = 5 * $bh_secondsInWeek;       // Maximum lookahead time - should be longer than the longest song possible (a bit longer is handy for debugging)
// $bh_pre_file_time  = 1 * $bh_secondsInDay;       // Maximum lookahead time - should be longer than the longest song possible
  $bh_now            = bh_time();                   // Current Unix time, UTC - ask just once to avoid inconsistencies

  if( isset( $argv) && array_key_exists( 0, $argv))
    $bh_return_count = $argv[ 1] + 1;               // Amount of 'early' items to return for sc_trans, plus one for the actual item
  else
    $bh_return_count = 4;                           // Return one if not specified by sc_trans



  // //////////////////////////////////////////////////////////////////////////
  //
  // read playlists, schedule, song cache and playlist pointers

  $bh_playlists         = bh_load_playlists        ( $bh_playlists_dir   );
  $bh_schedule          = bh_load_schedule         ( $bh_schedule_file   );
  $bh_song_cache        = bh_load_song_cache       ( $bh_cache_fn        );
  $bh_playlist_pointers = bh_load_playlist_pointers( $bh_playlist_data_fn);
  $bh_last_playlist     = bh_load_last_playlist();
  $bh_new_playlist      = $bh_last_playlist;

  if( count( $bh_playlists) <= 1)                   // We need at least one playlist file
    bh_panic( 'no playlists found in playlists directory');

  if( count( $bh_schedule) <= 2)                    // Schedule needs at least have a default line and a fillers line
    bh_panic( 'no valid schedule found in web_secrets directory - default item and or fillers item probbly are missing');

  // bh_debug( $bh_playlists        , 'playlists'        );
  // bh_debug( $bh_schedule         , 'schedule'         );
  // bh_debug( $bh_song_cache       , 'song cache'       );
  // bh_debug( $bh_playlist_pointers, 'playlist pointers');

  // . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

  // Figure out actual playlist lengths from the lists in the schedule and the timing info in the cache
  // do this for the default list too, and make a schedule compatible default item as well.
  // Also get file counts.

  $bh_defaults_found = false;
  $bh_default_list   = '';                          // default playlist            - to be obtained from schedule
  $bh_default_author = '';                          // Author for default playlist - to be obtained from schedule
  $bh_filler_found   = false;
  $bh_filler_list    = '';                          // filler playlist             - to be obtained from schedule
  $bh_filler_author  = '';                          // Author for filler playlist  - to be obtained from schedule
  $bh_sorter         = array();                     // Will have a schedule sorted on time when done

  foreach( $bh_schedule as $sched)
  {
    // bh_debug( $sched, 'schedule item');

    if( array_key_exists( 'default_file', $sched))
    {
      $bh_default_author = $sched[ 'default_author' ];    // bh_debug( $bh_default_author, 'default author');
      $bh_default_list   = $sched[ 'default_file'   ];    // bh_debug( $bh_default_list  , 'default list'  );
      $bh_defaults_found = true;
    }
    else if( array_key_exists( 'filler_file', $sched))
    {
      $bh_filler_author = $sched[ 'filler_author' ];      // bh_debug( $bh_filler_author, 'filler author');
      $bh_filler_list   = $sched[ 'filler_file'   ];      // bh_debug( $bh_filler_list  , 'filler list'  );
      $bh_filler_found  = true;
    }
    else
    {
      // bh_debug( $sched, 'schedule item');

      $visible  = $sched[ 'visible' ] == 'on';
      $playable = $sched[ 'playable'] == 'on';

      if( $visible && $playable)
      {
        $bh_week_day      = $sched[ 'day'       ];
        $bh_schedule_type = $sched[ 'type'      ];
        $bh_anchor        = $sched[ 'anchor'    ];
        $bh_start_time    = $sched[ 'start'     ];
        $bh_duration      = $sched[ 'duration'  ] * $bh_secondsInMinute;
        $bh_file          = $sched[ 'file'      ];
        $bh_author        = $sched[ 'author'    ];
        $bh_file          = $sched[ 'file'      ];
        $bh_day_mask      = $sched[ 'day_mask'  ];
        $bh_auto_reset    = $sched[ 'auto_reset'];

        // See if within reasonable time frame

        $bh_file_start  = bh_makeStartTime( $bh_file, $bh_now, $bh_week_day, $bh_day_mask, $bh_schedule_type, $bh_anchor, $bh_start_time, $bh_duration);
        $bh_frame_start = $bh_file_start - $bh_pre_file_time;
        $bh_file_end    = $bh_file_start + $bh_duration;
        $bh_frame_end   = $bh_file_start + $bh_duration;

        bh_debug_time( $bh_frame_start, 'visibility frame start');
        bh_debug_time( $bh_file_start , 'file start'            );
        bh_debug_time( $bh_file_end   , 'file end'              );
        bh_debug_time( $bh_frame_end  , 'visibility frame end'  );

        if(( $bh_now >= $bh_frame_start) && ( $bh_now <= $bh_frame_end))
        {
          bh_debug_time( $bh_file_start, 'point 60 - in visible time frame');

          $bh_is_live = ( $bh_now >= $bh_file_start) && ( $bh_now <= $bh_file_end);
          $bh_info    = getdate( $bh_file_start);
          $listname   = $bh_file;
          $playtime   = bh_get_list_playtime( $listname, $bh_playlists, $bh_song_cache); // bh_debug( $playtime, "playtime for list '$listname'");

          $bh_sorter[] = array(
            'start_time'   => $bh_file_start,
            'duration'     => $bh_duration,
            'is_live'      => $bh_is_live,
            'year'         => $bh_info[ "year"   ],
            'month'        => $bh_info[ "mon"    ],
            'mday'         => $bh_info[ "mday"   ],
            'hours'        => $bh_info[ "hours"  ],
            'minutes'      => $bh_info[ "minutes"],
            'author'       => $bh_author,
            'file'         => $bh_file,
            'is_default'   => false,
            'is_filler'    => false,
            'playtime'     => $playtime,
            'auto_reset'   => $bh_auto_reset == 'on',
            'day_mask'     => $bh_day_mask,
            'song_pointer' => bh_get_playlist_pointer( $bh_playlist_pointers, $listname),
            'song_count'   => bh_get_song_count( $bh_playlists, $listname)
          );
        }
        else
        {
          bh_debug_time( $bh_file_start, 'point 60 : not in visible time frame');
        }
      }
    }
  }

  if( ! $bh_defaults_found)
    bh_panic( 'schedule in web_secrets directory has no default settings');

  if( ! $bh_filler_found)
  {
    $bh_filler_author = $bh_default_author;
    $bh_filler_list   = $bh_default_list;
  }

  // Sort $bh_sorter on start_time
  //   Don't use an anonymous function here our PHP Version is 5.1.6 ( < 5.3.0 ).

  function bh_cmp( $a, $b)
  {
    return (( int) $a[ "start_time"]) - (( int) $b[ "start_time"]);
  }

  usort( $bh_sorter, "bh_cmp");
  $bh_schedule = $bh_sorter;


  // Add the default item as the last item

  $bh_info = getdate( $bh_now);

  $bh_default_sched = array(                  // Schedule compatible default item
    'start_time'   => $bh_now,                // ! important
    'duration'     => $bh_pre_file_time,      // ! important
    'is_live'      => true,                   // ! important
    'year'         => $bh_info[ "year"   ],   // informative only, not used here, handy for debugging
    'month'        => $bh_info[ "mon"    ],   // informative only, not used here, handy for debugging
    'mday'         => $bh_info[ "mday"   ],   // informative only, not used here, handy for debugging
    'hours'        => $bh_info[ "hours"  ],   // informative only, not used here, handy for debugging
    'minutes'      => $bh_info[ "minutes"],   // informative only, not used here, handy for debugging
    'author'       => $bh_default_author,
    'file'         => $bh_default_list,
    'is_default'   => true,                   // ! important
    'is_filler'    => false,                  // ! important
    'auto_reset'   => '',                     // ! important
    'day_mask'     => '1111111',
    'playtime'     => bh_get_list_playtime( $bh_default_list, $bh_playlists, $bh_song_cache),
    'song_pointer' => bh_get_playlist_pointer( $bh_playlist_pointers, $bh_default_list),
    'song_count'   => bh_get_song_count( $bh_playlists, $bh_default_list)
  );
  $bh_schedule[] = $bh_default_sched;

  // Make a filler item too, and add it after ...

  $bh_info = getdate( 0);

  $bh_filler_sched = array(                   // Schedule compatible filler item
    'start_time'   => 0,                      // ! important
    'duration'     => $bh_pre_file_time,      // ! important
    'is_live'      => false,                  // ! important
    'year'         => $bh_info[ "year"   ],   // informative only, not used here, handy for debugging
    'month'        => $bh_info[ "mon"    ],   // informative only, not used here, handy for debugging
    'mday'         => $bh_info[ "mday"   ],   // informative only, not used here, handy for debugging
    'hours'        => $bh_info[ "hours"  ],   // informative only, not used here, handy for debugging
    'minutes'      => $bh_info[ "minutes"],   // informative only, not used here, handy for debugging
    'author'       => $bh_filler_author,
    'file'         => $bh_filler_list,
    'is_default'   => false,                  // ! important
    'is_filler'    => true,                   // ! important
    'auto_reset'   => '',                     // ! important
    'day_mask'     => '1111111',
    'playtime'     => bh_get_list_playtime( $bh_filler_list, $bh_playlists, $bh_song_cache),
    'song_pointer' => bh_get_playlist_pointer( $bh_playlist_pointers, $bh_filler_list),
    'song_count'   => bh_get_song_count( $bh_playlists, $bh_filler_list)
  );
  $bh_schedule[] = $bh_filler_sched;

  // bh_debug( $bh_return_count, 'number of songs to be returned to sc_trans (on stdout)');
  // bh_debug( $bh_song_count  , 'number of songs returned to sc_trans (on stdout) sofar');


  // First find the first live item, the last item is the default item, so will always find a live item

  bh_debug_schedule ( $bh_schedule);

  $sched = bh_schedule_find_first_live_at_time( $bh_schedule, $bh_now);

  if( $sched == null) bh_panic( 'no live items found, while the default item should always be live');

  $bh_song_count      = 0;
  $bh_collected_songs = array();
  $bh_schedule_count  = count( $bh_schedule);
  $accu_time          = $bh_now;
  $orig_song_pointer  = $sched[ 'song_pointer'];

  while( count( $bh_collected_songs) < $bh_return_count)
  {
    bh_debug( bh_format_utc( $accu_time), 'found live item for time');
    bh_debug_sched( $sched);

    $list_name    = $sched       [ 'file'        ];                       // bh_debug( $list_name        , 'list name'           );
    $song_count   = $sched       [ 'song_count'  ];
    $song_pointer = $sched       [ 'song_pointer'];
    $list_info    = $bh_playlists[ $list_name    ];                       // bh_debug( $list_info        , 'list info'           );
    $songs        = $list_info   [ 'data'        ];                       // bh_debug( $songs            , 'songs'               );

    if( $list_name != $bh_last_playlist)
    {
      $bh_new_playlist = $list_name;
      if(( $sched[ 'auto_reset'] == 'on') && ! $sched[ 'is_default'])     // Never auto reset the default list
      {
        $song_pointer      = 0;
        $orig_song_pointer = 0;
        bh_debug( 'schedule changed to a new playlist and song pointer was reset to zero'); bh_debug( $bh_last_playlist, 'last playlist'); bh_debug( $bh_new_playlist , 'new  playlist');
      }
    }

    bh_fix_song_pointer( $song_pointer, $sched, $song_count, $list_name);           // has some side fx ...

    $song_filename = $songs[ $song_pointer];                                        bh_debug( $song_filename, 'candidate song');
    $song_duration = bh_get_song_playtime( $songs[ $song_pointer], $bh_song_cache); bh_debug( bh_format_duration( $song_duration), 'candidate song duration');

    $next_accu_time = $accu_time + $song_duration;
    $next_sched     = bh_schedule_find_first_over_time( $bh_schedule, $next_accu_time);

    if( ! bh_same_sched( $sched, $next_sched) && ! $next_sched[ 'is_default'])
    {
      bh_debug( 'playlist would run into a programmed play list, find an alternative song from the current list');

      // Find first fitting song in the current list, which is the default list, so we can just advance the
      // song pointer as we see fit ... it's a random list anyway.

      $done       = false;
      $loop_limit = $song_count;    // No use to loop more often than we have songs ...

      while( ! $done && $loop_limit-- > 0)
      {
        bh_advance_song_pointer( $song_pointer, $sched, $song_count, $list_name);       // has some side fx ...

        $song_filename = $songs[ $song_pointer];                                        bh_debug( $song_filename, 'next candidate song');
        $song_duration = bh_get_song_playtime( $songs[ $song_pointer], $bh_song_cache); bh_debug( bh_format_duration( $song_duration), 'next candidate song duration');

        $next_accu_time = $accu_time + $song_duration;
        $next_sched     = bh_schedule_find_first_over_time( $bh_schedule, $next_accu_time);

        if( ! bh_same_sched( $sched, $next_sched) && ! $next_sched[ 'is_default'])
          bh_debug( 'playlist would run into a programmed play list, find a next alternative song from the current list, loop once more');
        else
        {
          $bh_collected_songs[] = $song_filename;                                       bh_debug( $bh_collected_songs, 'next candidate song fits, added it to the result list');
          $accu_time = $next_accu_time;
          $done = true;
        }
      }

      $song_pointer = $orig_song_pointer;
      bh_advance_song_pointer( $song_pointer, $sched, $song_count, $list_name);

      if( ! $done)
      {
        bh_debug( 'no fitting song found, switch to the very short thingie');
     // $sched             = $next_sched;
        $sched = $bh_schedule[ $bh_schedule_count - 1];
        $orig_song_pointer = $sched[ 'song_pointer'];

        while( ! $done && $loop_limit-- > 0)
        {
          bh_advance_song_pointer( $song_pointer, $sched, $song_count, $list_name);       // has some side fx ...

          $song_filename = $songs[ $song_pointer];                                        bh_debug( $song_filename, 'next candidate song');
          $song_duration = bh_get_song_playtime( $songs[ $song_pointer], $bh_song_cache); bh_debug( bh_format_duration( $song_duration), 'next candidate song duration');

          $next_accu_time = $accu_time + $song_duration;
          $next_sched     = bh_schedule_find_first_over_time( $bh_schedule, $next_accu_time);

          if( ! bh_same_sched( $sched, $next_sched) && ! $next_sched[ 'is_default'])
            bh_debug( 'playlist would run into a programmed play list, find a next alternative song from the current list, loop once more');
          else
          {
            $bh_collected_songs[] = $song_filename;                                       bh_debug( $bh_collected_songs, 'next candidate song fits, added it to the result list');
            $accu_time = $next_accu_time;
            $done = true;
          }
        }

        $song_pointer = $orig_song_pointer;
        bh_advance_song_pointer( $song_pointer, $sched, $song_count, $list_name);

        if( ! $done)
        {
          bh_debug( 'no fitting song found, just switch to the next schedule, maybe a tad early ... could use the very_short tracks thingie here');
          $sched             = $next_sched;
          $orig_song_pointer = $sched[ 'song_pointer'];
        }
      }
    }
    else
    {
      $bh_collected_songs[] = $song_filename;                                           bh_debug( $bh_collected_songs, 'candidate song fits, added it to the result list');
      bh_advance_song_pointer( $song_pointer, $sched, $song_count, $list_name);       // has some side fx ...
      $accu_time = $next_accu_time;
    }
  }

  // Save the probably changed playlist pointers (but not with plain debugging only)
  // same for the last playlist

  if( ! $bh_debug || $bh_pointer_debug)
  {
    bh_save_playlist_pointers( $bh_playlist_data_fn, $bh_playlist_pointers);
    bh_save_last_playlist( $bh_new_playlist);
  }

  // Return data to caller through stdout

  print( implode( "\n", $bh_collected_songs));

?>
