<?php

  // todo :
  //
  //   2012-07-31 : option to end scheduled playlist and not repeat. [If it is shorter than the scheduled time].
  //
  //   2012-07-31 : option to fade out scheduled playlist at it's scheduled time and not to run over. [thus
  //                wiping out anything that follows directly in the schedule.]
  //
  //   2012-08-05 : Les wants playlists to fuck.
  //
  // done :
  //
  //   2012-07-20 : Just one problem left ... when a regular item becomes live soon and we picked items
  //                from the default list the scheduled item will start late .. or not at all. This is not
  //                easy to fix within this program ...
  //
  //                hmm .. returning random tracks now here and there to fill gaps and such ... not really
  //                a great idea maybe as the tracks will change on each call ... it'll do for now.
  //
  //   2012-07-31 : Added clear option for playlist pointers.
  //
  //   2012-08-04 : Made daily playlists work.
  //
  //   2012-08-05 : fixed playlist cache tools on server so that it has info on the station calls too.
  //
  //   2012-08-05 : phobos__the_minikp_sessions__03_kaoss_feedback_drone_excerpt_may_06_2011_293 wont go into
  //                the cache ??? - playlist_sort.php (the playlist sorter / organizer) had a field limit
  //                of 120 characters on the track name - set that to 512 to fix it; the cache was okay.
  //
  //   2012-08-06 : made support for auto song pointer reset when a schedule item gets scheduled
  //


  // //////////////////////////////////////////////////////////////////////////
  //
  // definitions

  $on_host = strtoupper( substr( PHP_OS, 0, 3)) === 'WIN' ? false : true;
  if( ! defined( 'IN_PLAYLIST'))
  {
    define( 'IN_PLAYLIST', 1);
  }
  require_once( 'playlist_settings.php');           // Global settings for finding stuff
  require_once( 'playlist_tools.php'   );           // Supporting code

  // For production code all debugging needs to be off, for debugging specify it on the command line

  $bh_debug          = bh_read_get_param( 'debug'        , 1, false); // Overall debugging
  $bh_use_time_debug = bh_read_get_param( 'time_debug'   , 1, false); // Schedule timing debugging
  $bh_cache_debug    = bh_read_get_param( 'cache_debug'  , 1, false); // Caching actions debugging
  $bh_pointer_debug  = bh_read_get_param( 'pointer_debug', 1, false); // playlist pointer debugging


  // --------------------------------------------------------------------------------------
  //
  // Visibility window

  $bh_pre_file_time  = 5 * $bh_secondsInWeek;        // Maximum lookahead time - should be longer than the longest song possible (a bit longer is handy for debugging)
// $bh_pre_file_time  = 1 * $bh_secondsInDay;        // Maximum lookahead time - should be longer than the longest song possible
  $bh_now            = time() /*- 25 * 60*/;         // Current Unix time, UTC - ask just once to avoid inconsistencies

  if( isset( $argv) && array_key_exists( 0, $argv))
    $bh_return_count = $argv[ 1] + 1;               // Amount of 'early' items to return for sc_trans, plus one for the actual item
  else
    $bh_return_count = 4;                           // Return one if not specified by sc_trans



  // //////////////////////////////////////////////////////////////////////////
  //
  // read playlists, schedule, song cache and playlist pointers

  $bh_playlists         = bh_load_playlists        ( $bh_playlists_dir   );
  $bh_schedule          = bh_load_schedule         ( $bh_schedule_file   );
  $bh_song_cache        = bh_load_song_cache       ( $bh_cache_fn        );
  $bh_playlist_pointers = bh_load_playlist_pointers( $bh_playlist_data_fn);
  $bh_last_playlist     = bh_load_last_playlist();
  $bh_new_playlist      = $bh_last_playlist;

  if( count( $bh_playlists) <= 1)                   // We need at least one playlist file
    bh_panic( 'no playlists found in playlists directory');

  if( count( $bh_schedule) <= 1)                    // Schedule needs at least have a default line and a fillers line
    bh_panic( 'no valid schedule found in web_secrets directory - default item and or fillers item probbly are missing');

  // bh_debug( $bh_playlists        , 'playlists'        );
  // bh_debug( $bh_schedule         , 'schedule'         );
  // bh_debug( $bh_song_cache       , 'song cache'       );
  // bh_debug( $bh_playlist_pointers, 'playlist pointers');


  // . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

  // Figure out actual playlist lengths from the lists in the schedule and the timing info in the cache
  // do this for the default list too, and make a schedule compatible default item as well.
  // Also get file counts.

  $bh_defaults_found = false;
  $bh_default_list   = '';                          // default playlist            - to be obtained from schedule
  $bh_default_author = '';                          // Author for default playlist - to be obtained from schedule
  $bh_filler_found   = false;
  $bh_filler_list    = '';                          // filler playlist             - to be obtained from schedule
  $bh_filler_author  = '';                          // Author for filler playlist  - to be obtained from schedule
  $bh_sorter         = array();                     // Will have a schedule sorted on time when done

  foreach( $bh_schedule as $sched)
  {
    // bh_debug( $sched, 'schedule item');

    if( array_key_exists( 'default_file', $sched))
    {
      $bh_default_author = $sched[ 'default_author' ];    // bh_debug( $bh_default_author, 'default author');
      $bh_default_list   = $sched[ 'default_file'   ];    // bh_debug( $bh_default_list  , 'default list'  );
      $bh_defaults_found = true;
    }
    else if( array_key_exists( 'filler_file', $sched))
    {
      $bh_filler_author = $sched[ 'filler_author' ];      // bh_debug( $bh_filler_author, 'filler author');
      $bh_filler_list   = $sched[ 'filler_file'   ];      // bh_debug( $bh_filler_list  , 'filler list'  );
      $bh_filler_found  = true;
    }
    else
    {
      // bh_debug( $sched, 'schedule item');

      $visible  = $sched[ 'visible' ] == 'on';
      $playable = $sched[ 'playable'] == 'on';

      if( $visible && $playable)
      {
        $bh_week_day      = $sched[ 'day'       ];
        $bh_schedule_type = $sched[ 'type'      ];
        $bh_anchor        = $sched[ 'anchor'    ];
        $bh_start_time    = $sched[ 'start'     ];
        $bh_duration      = $sched[ 'duration'  ] * $bh_secondsInMinute;
        $bh_file          = $sched[ 'file'      ];
        $bh_author        = $sched[ 'author'    ];
        $bh_file          = $sched[ 'file'      ];
        $bh_day_mask      = $sched[ 'day_mask'  ];
        $bh_auto_reset    = $sched[ 'auto_reset'];

        // See if within reasonable time frame

        $bh_file_start  = bh_makeStartTime( $bh_file, $bh_now, $bh_week_day, $bh_day_mask, $bh_schedule_type, $bh_anchor, $bh_start_time, $bh_duration);
        $bh_frame_start = $bh_file_start - $bh_pre_file_time;
        $bh_file_end    = $bh_file_start + $bh_duration;
        $bh_frame_end   = $bh_file_start + $bh_duration;

        bh_debug_time( $bh_frame_start, 'visibility frame start');
        bh_debug_time( $bh_file_start , 'file start'            );
        bh_debug_time( $bh_file_end   , 'file end'              );
        bh_debug_time( $bh_frame_end  , 'visibility frame end'  );

        if(( $bh_now >= $bh_frame_start) && ( $bh_now <= $bh_frame_end))
        {
          bh_debug_time( $bh_file_start, 'point 60 - in visible time frame');

          $bh_is_live = ( $bh_now >= $bh_file_start) && ( $bh_now <= $bh_file_end);
          $bh_info    = getdate( $bh_file_start);
          $listname   = $bh_file;
          $playtime   = bh_get_list_playtime( $listname, $bh_playlists, $bh_song_cache); // bh_debug( $playtime, "playtime for list '$listname'");

          $bh_sorter[] = array(
            'start_time'   => $bh_file_start,
            'duration'     => $bh_duration,
            'is_live'      => $bh_is_live,
            'year'         => $bh_info[ "year"   ],
            'month'        => $bh_info[ "mon"    ],
            'mday'         => $bh_info[ "mday"   ],
            'hours'        => $bh_info[ "hours"  ],
            'minutes'      => $bh_info[ "minutes"],
            'author'       => $bh_author,
            'file'         => $bh_file,
            'is_default'   => false,
            'is_filler'    => false,
            'playtime'     => $playtime,
            'auto_reset'   => $bh_auto_reset == 'on',
            'day_mask'     => $bh_day_mask,
            'song_pointer' => bh_get_playlist_pointer( $bh_playlist_pointers, $listname),
            'song_count'   => bh_get_song_count( $bh_playlists, $listname)
          );
        }
        else
        {
          bh_debug_time( $bh_file_start, 'point 60 : not in visible time frame');
        }
      }
    }
  }

  if( ! $bh_defaults_found)
    bh_panic( 'schedule in web_secrets directory has no default settings');

  if( ! $bh_filler_found)
  {
    $bh_filler_author = $bh_default_author;
    $bh_filler_list   = $bh_default_list;
  }

  // Sort $bh_sorter on start_time
  //   Don't use an anonymous function here our PHP Version is 5.1.6 ( < 5.3.0 ).

  function bh_cmp( $a, $b)
  {
    return (( int) $a[ "start_time"]) - (( int) $b[ "start_time"]);
  }

  usort( $bh_sorter, "bh_cmp");
  $bh_schedule = $bh_sorter;


  // Add the default item as the last item

  $bh_info = getdate( $bh_now);

  $bh_default_sched = array(                  // Schedule compatible default item
    'start_time'   => $bh_now,                // ! important
    'duration'     => $bh_pre_file_time,      // ! important
    'is_live'      => true,                   // ! important
    'year'         => $bh_info[ "year"   ],   // informative only, not used here, handy for debugging
    'month'        => $bh_info[ "mon"    ],   // informative only, not used here, handy for debugging
    'mday'         => $bh_info[ "mday"   ],   // informative only, not used here, handy for debugging
    'hours'        => $bh_info[ "hours"  ],   // informative only, not used here, handy for debugging
    'minutes'      => $bh_info[ "minutes"],   // informative only, not used here, handy for debugging
    'author'       => $bh_default_author,
    'file'         => $bh_default_list,
    'is_default'   => true,                   // ! important
    'is_filler'    => false,                  // ! important
    'auto_reset'   => '',                     // ! important
    'day_mask'     => '1111111',
    'playtime'     => bh_get_list_playtime( $bh_default_list, $bh_playlists, $bh_song_cache),
    'song_pointer' => bh_get_playlist_pointer( $bh_playlist_pointers, $bh_default_list),
    'song_count'   => bh_get_song_count( $bh_playlists, $bh_default_list)
  );
  $bh_schedule[] = $bh_default_sched;

  // Make a filler item too, and add it after ...

  $bh_info = getdate( 0);

  $bh_filler_sched = array(                  // Schedule compatible filler item
    'start_time'   => 0,
    'duration'     => $bh_pre_file_time,      // ! important
    'is_live'      => false,                  // ! important
    'year'         => $bh_info[ "year"   ],   // informative only, not used here, handy for debugging
    'month'        => $bh_info[ "mon"    ],   // informative only, not used here, handy for debugging
    'mday'         => $bh_info[ "mday"   ],   // informative only, not used here, handy for debugging
    'hours'        => $bh_info[ "hours"  ],   // informative only, not used here, handy for debugging
    'minutes'      => $bh_info[ "minutes"],   // informative only, not used here, handy for debugging
    'author'       => $bh_filler_author,
    'file'         => $bh_filler_list,
    'is_default'   => false,                  // ! important
    'is_filler'    => true,                   // ! important
    'auto_reset'   => '',                     // ! important
    'day_mask'     => '1111111',
    'playtime'     => bh_get_list_playtime( $bh_filler_list, $bh_playlists, $bh_song_cache),
    'song_pointer' => bh_get_playlist_pointer( $bh_playlist_pointers, $bh_filler_list),
    'song_count'   => bh_get_song_count( $bh_playlists, $bh_filler_list)
  );
  $bh_schedule[] = $bh_filler_sched;

  // bh_debug( $bh_return_count, 'number of songs to be returned to sc_trans (on stdout)');
  // bh_debug( $bh_song_count  , 'number of songs returned to sc_trans (on stdout) sofar');


  // Find live schedule items to extract songs from ... the idea is ...
  //
  // Find the first live item and collect songs from that till either there are enough songs
  // or the last song collected would oveflow the scheduled end time. When there are not enough
  // songs after going over the end time find the next item that is live. The last item in the schedule
  // must be the default playlist, which we set to be very long and to be starting now, it is always live
  // (therfore) so when no live items can be found on the regular schedule items will be picked from
  // the default list. Note the ! important settings for the default list.


  $bh_song_count      = 0;
  $bh_collected_songs = array();
  $bh_schedule_count  = count( $bh_schedule);

  for( $bh_schedule_index = 0; $bh_schedule_index < $bh_schedule_count; $bh_schedule_index++)
  {
    $sched          = $bh_schedule[ $bh_schedule_index];
    $has_next_sched = $bh_schedule_index < $bh_schedule_count - 1;
    $is_live        = $sched[ 'is_live'];

    if( $is_live)
    {
      bh_debug( '* found live item');
                                                                  bh_debug( $bh_now           , 'now'                 );
      $is_default   = $sched       [ 'is_default'  ];             bh_debug( $is_default       , 'is default'          );
      $is_filler    = $sched       [ 'is_filler'   ];             bh_debug( $is_filler        , 'is filler'           );
      $list_name    = $sched       [ 'file'        ];             bh_debug( $list_name        , 'list name'           );
      $song_count   = $sched       [ 'song_count'  ];             bh_debug( $song_count       , 'song count'          );
      $song_pointer = $sched       [ 'song_pointer'];             bh_debug( $song_pointer     , 'song pointer'        );
      $list_info    = $bh_playlists[ $list_name    ];          // bh_debug( $list_info        , 'list info'           );
      $songs        = $list_info   [ 'data'        ];          // bh_debug( $songs            , 'songs'               );
      $auto_reset   = $sched       [ 'auto_reset'  ] == 'on';     bh_debug( $auto_reset       , 'auto reset'          );

      $accu_time = $bh_now;
      $end_time  = $sched[ 'start_time'  ] + $sched[ 'duration']; bh_debug( $end_time         , 'end time'            );

      if( $list_name != $bh_last_playlist)
      {
        $bh_new_playlist = $list_name;
        if( $auto_reset && ! $is_default) // Never auto reset the default list
        {
          $song_pointer                      = 0;
          $bh_playlist_pointers[ $list_name] = 0;
        }
      }

      // also try to find the next thing - that is the thing scheduled after

      if( $has_next_sched)
      {
        $next_sched        = $bh_schedule[ $bh_schedule_index + 1];
        $next_is_default   = $next_sched    [ 'is_default'   ];           bh_debug( $next_is_default  , 'next is default'     );
        $next_is_filler    = $next_sched    [ 'is_filler'    ];           bh_debug( $next_is_filler   , 'next is filler'      );
        $next_list_name    = $next_sched    [ 'file'         ];           bh_debug( $next_list_name   , 'next list name'      );
        $next_song_count   = $next_sched    [ 'song_count'   ];           bh_debug( $next_song_count  , 'next song count'     );
        $next_song_pointer = $next_sched    [ 'song_pointer' ];           bh_debug( $next_song_pointer, 'next song pointer'   );
        $next_list_info    = $bh_playlists  [ $next_list_name];        // bh_debug( $next_list_info   , 'next list info'      );
        $next_songs        = $next_list_info[ 'data'         ];        // bh_debug( $next_songs       , 'next songs'          );
        $next_auto_reset   = $next_sched    [ 'auto_reset'   ] == 'on';   bh_debug( $auto_reset       , 'next auto reset'     );
      }
      else if( $is_default && $bh_schedule_count > 0)
      {
        $next_sched        = $bh_schedule[ 0];
        $next_is_default   = $next_sched    [ 'is_default'   ];           bh_debug( $next_is_default  , 'next is default'     );
        $next_is_filler    = $next_sched    [ 'is_filler'    ];           bh_debug( $next_is_filler   , 'next is filler'      );
        $next_list_name    = $next_sched    [ 'file'         ];           bh_debug( $next_list_name   , 'next list name'      );
        $next_song_count   = $next_sched    [ 'song_count'   ];           bh_debug( $next_song_count  , 'next song count'     );
        $next_song_pointer = $next_sched    [ 'song_pointer' ];           bh_debug( $next_song_pointer, 'next song pointer'   );
        $next_list_info    = $bh_playlists  [ $next_list_name];        // bh_debug( $next_list_info   , 'next list info'      );
        $next_songs        = $next_list_info[ 'data'         ];        // bh_debug( $next_songs       , 'next songs'          );
        $next_auto_reset   = $next_sched    [ 'auto_reset'   ] == 'on';   bh_debug( $auto_reset       , 'next auto reset'     );

        $has_next_sched    = true;

        // if current up is the default list then change it's end time to the start time of the next scheduled one
        // but do not 'abort' other playlists? hmm .. indeed not they would go over their scheduled end time then

        if( $is_default)
        {
          $end_time = $next_sched[ 'start_time'];                 bh_debug( $end_time         , 'end time changed to' );
        }
      }

      // bh_debug( $accu_time , 'accu_time' );
      // bh_debug( $end_time  , 'end_time'  );

      $bh_loop_count = 0;

      while(
        $bh_song_count    < $bh_return_count &&
        $accu_time        < $end_time        &&
        $bh_loop_count++  < 5
      )
      {
        if( $song_pointer >= $song_count)
          $song_pointer = 0;

        $song_filename = $songs[ $song_pointer];
        $song_length   = bh_get_song_playtime( $songs[ $song_pointer], $bh_song_cache);

        if(( $accu_time + $song_length > $end_time) && $is_default)
        {
          bh_debug( "** default list would go over end time, do not add $song_filename");

          // Collect some short ones from the filler list here to fill the gap

          $bh_wanted_song_count = $bh_return_count - $bh_song_count;
          $bh_gap_time          = $end_time - $accu_time;
          $bh_filler            = bh_collect_songs( $bh_song_cache, $bh_playlists[ $bh_filler_list], $bh_playlists, $bh_gap_time, $bh_wanted_song_count, -1 /* using random*/);
          foreach( $bh_filler as $bh_song)
          {
            $song_filename        = $bh_song;
            $bh_collected_songs[] = $song_filename;
            bh_debug( "** added $song_filename from $bh_filler_list (filler) to collected songs");
            $bh_song_count++;
          }

          // done : and then if we are not over $song_count also go into the next list

          if( $bh_song_count >= $bh_return_count)
            break;

          // done : ok ... not filled up yet ... get a couple from the next schedule

          $bh_wanted_song_count = $bh_return_count - $bh_song_count;
          $bh_gap_time          = $end_time - $accu_time;

          if( $next_song_pointer >= $next_song_count)
            $next_song_pointer = 0;
          $bh_filler = bh_collect_songs( $bh_song_cache, $next_list_info, $bh_playlists, $bh_gap_time, $bh_wanted_song_count, $next_song_pointer);
          foreach( $bh_filler as $bh_song)
          {
            $bh_song_count++;
            $song_filename        = $bh_song;
            $bh_collected_songs[] = $song_filename;
            bh_debug( "** added $song_filename from $next_list_name (next schedule item) to collected songs");
          }
          $bh_playlist_pointers[ $next_list_name] = ( $bh_playlist_pointers[ $next_list_name] + 1) % $next_song_count;

        }
        else // allow non-default list to go over end time by length of last song
        {
          $accu_time += $song_length;
          $bh_collected_songs[] = $song_filename;
          bh_debug( "** added $song_filename from $list_name (current schedule item) to collected songs");
          $bh_song_count++;
          $song_pointer++;

          // done : ... okay ... but still if not enough songs returned when $accu_time is over $end_time
          //            we still need to add one or more songs from the default list ... just add some random stuff

          if( $accu_time > $end_time)
          {
            $bh_wanted_song_count = $bh_return_count - $bh_song_count;
            $bh_gap_time          = $bh_pre_file_time;                      // Just a very long time ...
            $bh_filler            = bh_collect_songs( $bh_song_cache, $bh_playlists[ $bh_default_list], $bh_playlists, $bh_gap_time, $bh_wanted_song_count, -1 /* using random*/);
            foreach( $bh_filler as $bh_song)
            {
              $song_filename        = $bh_song;
              $bh_collected_songs[] = $song_filename;
              bh_debug( "** added $song_filename from $bh_default_list (default) to collected songs");
              $bh_song_count++;
            }
          }
        }


        if( $song_pointer >= $song_count)
          $song_pointer = 0;

        // bh_debug( $song_filename, 'song filename');
        // bh_debug( $song_pointer , 'song pointer' );
        // bh_debug( $accu_time    , 'accu_time'    );
      }

      // Increment song pointer by one, not by the number of items returned to sc_trans

      $sched               [ 'song_pointer'] = ( $sched               [ 'song_pointer'] + 1) % $song_count;
      $bh_playlist_pointers[ $list_name    ] = ( $bh_playlist_pointers[ $list_name    ] + 1) % $song_count;
    }

    if( $bh_song_count >= $bh_return_count)
      break;
  }

  // bh_debug( $bh_return_count   , 'number of songs to be returned to sc_trans (on stdout)');
  // bh_debug( $bh_song_count     , 'number of songs returned to sc_trans (on stdout) sofar');
  // bh_debug( $bh_collected_songs, 'songs returned');

  // bh_debug( $bh_schedule);

  bh_debug_schedule ( $bh_schedule );
  // bh_debug_playlists( $bh_playlists);


  // //////////////////////////////////////////////////////////////////////////

  // playlists and schedule available


  // Save the probably changed playlist pointers (but not with plain debugging)

  bh_debug( $bh_last_playlist, 'last playlist');
  bh_debug( $bh_new_playlist , 'new  playlist');

  if( ! $bh_debug || $bh_pointer_debug)
  {
    bh_save_playlist_pointers( $bh_playlist_data_fn, $bh_playlist_pointers);
    bh_save_last_playlist( $bh_new_playlist);
  }


  // Return data to caller through stdout

  print( implode( "\n", $bh_collected_songs));

?>
