<?php

  // --------------------------------------------------------------------------------------

  $on_host = strtoupper( substr( PHP_OS, 0, 3)) === 'WIN' ? false : true;
  $prefix  = '';
  $caller  = 'playlist_schedule';

  if( $on_host)
  {
    $prefix = '../../playlist_stuff/';
  }


  if( ! defined( 'IN_PLAYLIST'))
  {
    define( 'IN_PLAYLIST', 1);
  }
  require_once( $prefix . 'playlist_settings.php');
  require_once( $prefix . 'playlist_tools.php'   );

  $bh_debug = true;            // Allow for debug info to clutter up the page

  bh_set_uncached();           // This file works on live data, so it should not be cached

  // --------------------------------------------------------------------------------------

  $bh_schedule = bh_load_schedule( $bh_schedule_file);


  // --------------------------------------------------------------------------------------

  function pretty_day( $day)
  {
         if( $day == 'mon') $result = 'Monday';
    else if( $day == 'tue') $result = 'Tuesday';
    else if( $day == 'wed') $result = 'Wednesday';
    else if( $day == 'thu') $result = 'Thursday';
    else if( $day == 'fri') $result = 'Friday';
    else if( $day == 'sat') $result = 'Saturday';
    else if( $day == 'sun') $result = 'Sunday';

    return $result;
  }

  // --------------------------------------------------------------------------------------

  function pretty_num_day( $day)
  {
         if( $day == 0) $result = 'Monday';
    else if( $day == 1) $result = 'Tuesday';
    else if( $day == 2) $result = 'Wednesday';
    else if( $day == 3) $result = 'Thursday';
    else if( $day == 4) $result = 'Friday';
    else if( $day == 5) $result = 'Saturday';
    else if( $day == 6) $result = 'Sunday';

    return $result;
  }

  // --------------------------------------------------------------------------------------

  function pretty_time( $time)
  {
    $result = substr( $time, 0, 2) . ':' . substr( $time, 2, 2);

    return $result;
  }

  // --------------------------------------------------------------------------------------

  function pretty_time_range( $time, $duration)
  {
    $result = $time . ' GMT ' . $duration . ' min.';

    return $result;
  }

  // --------------------------------------------------------------------------------------

  function pretty_day_mask( $day_mask)
  {
    $result = '';

    $days = array();
    $len  = strlen( $day_mask);

    for( $i = 0; $i < $len; $i++)
    {
      if( $day_mask[ $i] == '1')
        $days[] = pretty_num_day( $i);
    }

    $result = implode( ', ', $days);

    return $result;
  }

  // --------------------------------------------------------------------------------------

  function print_entry( $day, $schedule_type, $start_time, $duration, $day_mask, $author)
  {
    $time_range = pretty_time_range( $start_time, $duration);

    if( $schedule_type == 'daily')
    {
      $days = pretty_day_mask( $day_mask);
      print( "every <span style=\"font-weight: bold;\">$days</span><br>");
    }
    else
    {
      print( "<span style=\"font-weight: bold;\">$day</span> $schedule_type:<br>");
    }
    print( "<span style=\"font-size: 9px; line-height: normal;\">$time_range<br>");
    print( "<span style=\"font-weight: bold;\">$author</span><br>");
    print( "<br>");

  }

  // --------------------------------------------------------------------------------------

?><!DOCTYPE HTML>
<html>

  <head>
    <title>Playlist Schedule</title>
    <style type = "text/css"><!--

      body
      {
        font-family : Verdana, arial, helvetica, sans-serif;
        font-size   : 8pt;
        color       : black;
        text-align  : left;
      }
    -->
    </style>
  </head>

  <body>
    <div class="main"><?php

        $index = 0;
        foreach( $bh_schedule as $d)
        {
          if( $index != 0)                              // Skip the dfault item
          {
            $visible       = $d[ 'visible'  ];
            $auto_motd     = $d[ 'playable' ];
            $day           = $d[ 'day'      ];
            $schedule_type = $d[ 'type'     ];
            $anchor        = $d[ 'anchor'   ];
            $start_time    = $d[ 'start'    ];
            $duration      = $d[ 'duration' ];
            $author        = $d[ 'author'   ];
            $playlist      = $d[ 'file'     ];
            $day_mask      = $d[ 'day_mask' ];

            if( $visible == 'on')
            {
              if( $schedule_type == 'once')
              {
                $schedule_type = $anchor;
              }
              if( $auto_motd != 'on')
              {
                $author .= ' [cancelled this time]';
              }
              print_entry(
                pretty_day( $day),
                $schedule_type,
                pretty_time( $start_time),
                $duration,
                $day_mask,
                $author
              );
            }
          }
          $index++;
        }

      ?>
    </div>
  </body>
</html>
