<?php


  // --------------------------------------------------------------------------------------

  $on_host = strtoupper( substr( PHP_OS, 0, 3)) === 'WIN' ? false : true;
  $prefix  = '';
  $caller  = 'playlist_schedule_data';

  if( $on_host)
  {
    $prefix = '../../playlist_stuff/';
  }


  if( ! defined( 'IN_PLAYLIST'))
  {
    define( 'IN_PLAYLIST', 1);
  }
  require_once( $prefix . 'playlist_settings.php');
  require_once( $prefix . 'playlist_tools.php'   );

  $bh_debug = true;            // Allow for debug info to clutter up the page

  bh_set_uncached();           // This file works on live data, so it should not be cached

  // --------------------------------------------------------------------------------------

  $bh_schedule = bh_load_schedule( $bh_schedule_file);


  // --------------------------------------------------------------------------------------

  // type out the file data with some comments

  print( "# Playlist schedule information.\r\n");
  print( "# ..............................\r\n");
  print( "#\r\n");
  print( "# The first item is the default playlist having just an author and a list name.\r\n");
  print( "# The default list will be live when no regular scheduled items are.\r\n");
  print( "#\r\n");
  print( "# [*, 0] visible       (on|off)       :: Non visible items should not be shown.\r\n");
  print( "# [*, 1] auto_motd     (on|off)       :: For internal use only, to update the motd.\r\n");
  print( "# [*, 2] day           (mon|tue|wed|thu|fri|sat|sun).\r\n");
  print( "# [*, 3] schedule_type (daily, weekly|week 1|week 1 and 3|week 2|week 2 and 4|week 3|week 4|week 5|once|every other week).\r\n");
  print( "#                                     :: A show with schedule type 'once' with an anchor in the past should not be shown.\r\n");
  print( "# [*, 4] anchor        (yyyy-mm-dd|-) :: For schedule_type 'once' it's the day the show is on.\r\n");
  print( "#                                     :: For schedule type 'every other week' it's the date of\r\n");
  print( "#                                     :: the first show that then runs once every 14 days.\r\n");
  print( "#                                     :: For other schedule types it's not used (with value '-').\r\n");
  print( "#                                     :: It is possible that inconsistent data will be read, so when you\r\n");
  print( "#                                     :: see a schedule type that needs an anchor but that gives '-'\r\n");
  print( "#                                     :: please do a re-read a little while later, it is being edited then.\r\n");
  print( "# [*, 5] start_time    (hhmm)         :: GMT.\r\n");
  print( "# [*, 6] duration      (minutes)      :: Don't expect it to be whole hours, or just a few hours ... \r\n");
  print( "#                                     :: for 24/7 it would be 7 * 24 * 60, but it could be just a couple of minutes too.\r\n");
  print( "# [*, 7] author        (text)         :: Max length 80 is characters.\r\n");
  print( "# [*, 8] list          (text)         :: Max length 80 is characters.\r\n");
  print( "# [*, 9] auto_reset    (on|off)       :: Automatic song pointer reset.'\r\n");
  print( "# [*,10] day_mask      (mon_tue_wed_thu_fri_sat_sun) - when the schedule type is 'daily'.\r\n");
  print( "# ======== ======== ======== ========\r\n");

  $i = 0;
  foreach( $bh_schedule as $d)
  {
    $j = 0;
    foreach( $d as $e)
    {
      $t = trim( $e);
      print( "[$i,$j]$t\r\n");
      $j++;
    }
    $i++;
  }
  print( "# ======== ======== ======== ========\r\n");

?>
